package apis

import (
	"duoduo/apis/bizhi/models"
	"duoduo/apis/pdd"
	"duoduo/models/bizhi"
	"duoduo/tools/app"
	"fmt"
	"github.com/gin-gonic/gin"
	"pmo/pkg/tools"
)

//获取用户openid，没有，注册用户
func OpenIdSet(c *gin.Context) {
	var inData models.OpenIdSetRequest
	var outData models.OpenIdSetResponse
	var sqlData bizhi.User
	var sql1 bizhi.User

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	url := fmt.Sprintf("https://api.weixin.qq.com/sns/jscode2session?appid=wx4a22fc1a791b34f2&secret=ca4b4fc0553002181b5106f3f4899924&js_code=%s&grant_type=authorization_code", inData.Code)

	val, err := pdd.DuoDuoGet(url)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	err = tools.JsonUnmarshal(val, &outData)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}
	if outData.Errcode != 0 {
		app.Error(c, outData.Errcode, err, outData.Errmsg)
		return
	}
	//查询数据
	sqlData.OpenID = outData.OpenId
	num := sqlData.GetNum()
	if num == 0 {
		if inData.OpenId != "" { //有上级
			sql1.OpenID = inData.OpenId
			//创建用户
			sqlData.CreateTime = tools.GetCurrentTimeStr()
			sqlData.UpdateTime = tools.GetCurrentTimeStr()
			sqlData.OpenID1 = inData.OpenId

			sqlData.Create()
		} else { //无上级用户
			//创建用户
			sqlData.CreateTime = tools.GetCurrentTimeStr()
			sqlData.UpdateTime = tools.GetCurrentTimeStr()
			sqlData.Create()
		}

	}

	app.OK(c, outData, app.Success)

}

//获取用户积分
func GetUserScore(c *gin.Context) {
	var inData models.GetUserScoreRequest
	var sqlData bizhi.User

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	sqlData.OpenID = inData.OpenId
	data, err := sqlData.GetScore()
	if err != nil {
		app.Error(c, 500, err, err.Error())
	}
	app.OK(c, data.Score, "成功")
}

func SubUserScore(c *gin.Context) {
	var inData models.SubUserScoreRequest
	var sqlData bizhi.User

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	sqlData.OpenID = inData.OpenId
	err = sqlData.SubScore(inData)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}
	app.OK(c, nil, "")

}
